﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using OrderSL.OrderService;

namespace OrderSL
{
    public partial class ProcesserCtrl : UserControl
    {
        //private DuplexServiceClient _proxy;
        private List<Order> _orders = new List<Order>();

        //public int ID { get; set; }

        public OrderServiceClient Proxy { get; set; }

        public ProcesserCtrl()
        {
            InitializeComponent();

            //EndpointAddress address = new EndpointAddress("http://localhost:4074/Service1.svc");
            //PollingDuplexHttpBinding binding = new PollingDuplexHttpBinding();
            //_proxy = new DuplexServiceClient(binding, address);
            //_proxy.UpdateOrderReceived += new EventHandler<UpdateOrderReceivedEventArgs>(_proxy_UpdateOrderReceived);


            this.Loaded += new RoutedEventHandler(ProcesserCtrl_Loaded);
        }

        void ProcesserCtrl_Loaded(object sender, RoutedEventArgs e)
        {
            if (Proxy != null)
            {
                Proxy.UpdateOrderReceived += new EventHandler<UpdateOrderReceivedEventArgs>(Proxy_UpdateOrderReceived);
            }
            dataGrid1.ItemsSource = _orders;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (dataGrid1.SelectedItem is Order)
            {
                var order = dataGrid1.SelectedItem as Order;
                if (!order.OK)
                {
                    order.OK = true;
                    Proxy.ProcessOrderAsync(order);
                }
            }
        }

        void Proxy_UpdateOrderReceived(object sender, UpdateOrderReceivedEventArgs e)
        {
            if (e.Error == null)
            {
                var order = _orders.FirstOrDefault(odr => odr.ID == e.order.ID);
                if (order == null)
                {
                    _orders.Add(e.order);

                }
                else
                {
                    order.Content = e.order.Content;
                    order.Name = e.order.Name;
                    order.OK = e.order.OK;
                }
                dataGrid1.ItemsSource = null;
                dataGrid1.ItemsSource = _orders;
            }
        }
    }
}
