﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using OrderSL.OrderService;

namespace OrderSL
{
    public partial class SenderCtrl : UserControl
    {
        public OrderServiceClient Proxy { get; set; }

        private List<Order> _orders = new List<Order>();

        //public int ID { get; set; }

        public SenderCtrl()
        {
            InitializeComponent();

            //EndpointAddress address = new EndpointAddress("http://localhost:4074/Service1.svc");
            //PollingDuplexHttpBinding binding = new PollingDuplexHttpBinding();
            //Proxy = new DuplexServiceClient(binding, address);



            base.Loaded += new RoutedEventHandler(SenderCtrl_Loaded);
        }

        void SenderCtrl_Loaded(object sender, RoutedEventArgs e)
        {
            if (Proxy != null)
            {
                Proxy.UpdateOrderReceived += new EventHandler<UpdateOrderReceivedEventArgs>(Proxy_UpdateOrderReceived);
            }
            dataGrid1.ItemsSource = _orders;
        }

        void Proxy_UpdateOrderReceived(object sender, UpdateOrderReceivedEventArgs e)
        {
            if (e.Error == null)
            {
                var order = _orders.FirstOrDefault(odr => odr.ID == e.order.ID);
                if (order == null)
                {
                    _orders.Add(e.order);
                }
                else
                {
                    order.Content = e.order.Content;
                    order.Name = e.order.Name;
                    order.OK = e.order.OK;
                }
                dataGrid1.ItemsSource = null;
                dataGrid1.ItemsSource = _orders;
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            string name = textBox1.Text;
            string content = textBox2.Text;

            if (string.IsNullOrEmpty(name) || string.IsNullOrEmpty(content))
            {
                MessageBox.Show("不能为空");
                return;
            }

            Proxy.SendOrderAsync(new Order { Name = name, Content = content });
        }
    }
}
