﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;

namespace WebApp
{
    public class OrderService : IOrderService
    {
        private static List<Order> Orders = new List<Order>();
        private static List<User> Users = new List<User>();

        public void ProcessOrder(Order order)
        {
            var client = OperationContext.Current.GetCallbackChannel<IOrderClient>();
            var user = Users.Find(u => u.Client == client);
            if (user != null)
            {
                var myOrder = Orders.Find(odr => odr.ID == order.ID);
                if (myOrder != null)
                {
                    if (myOrder.OK != order.OK)
                    {
                        myOrder.OK = order.OK;
                        myOrder.User.Client.UpdateOrder(myOrder);
                    }
                }
            }

        }
        public void SendOrder(Order order)
        {
            var client = OperationContext.Current.GetCallbackChannel<IOrderClient>();

            var user = Users.Find(u => u.Client == client);
            if (user != null)
            {
                Order newOrder = new Order
                {
                    ID = Order.CreateID(),
                    Name = order.Name,
                    Content = order.Content,
                    OK = false,
                    User = user
                };

                Orders.Add(newOrder);

                foreach (var processUser in Users.FindAll(u => u.UserType == UserType.审核者))
                {
                    processUser.Client.UpdateOrder(newOrder);
                }

                user.Client.UpdateOrder(newOrder);
            }
        }

        public UserType Login()
        {
            User u = new User();
            u.Client = OperationContext.Current.GetCallbackChannel<IOrderClient>();
            u.UserType = Users.Count == 0 ? UserType.审核者 : UserType.提交者;
            Users.Add(u);

            return u.UserType;
        }

    }

}
